// BV4242 is a touch keypad with LCD front panel
//

#ifndef _LIB_bvsv3_c
#define _LIB_bvsv3_c

#include <stdint.h>
#include <wiringPi.h>
#include <wiringPiI2C.h>

#define DEVICE_EEWRITE  0x91
#define DEVICE_EEREAD   0x90
#define DEVICE_ID       0xa1
#define DEVICE_VERSION  0xa0
#define DEVICE_RESET    0x95

// *****************************************************************************
// *****************************************************************************
void sv3_eewrite(int bus, uint8_t eeaddress, uint8_t databyte)
{
    wiringPiI2CWrite(bus,DEVICE_EEWRITE); // send command
    wiringPiI2CWrite(bus,eeaddress);
    wiringPiI2CWrite(bus,databyte);
}

// *****************************************************************************
// *****************************************************************************
uint8_t sv3_eeread(int bus, uint8_t eeaddress)
{
    wiringPiI2CWrite(bus,DEVICE_EEREAD); // send command
    wiringPiI2CWrite(bus,eeaddress);
    return wiringPiI2CRead(bus);
}

// *****************************************************************************
// *****************************************************************************
uint16_t sv3_deviceID(int bus)
{
uint16_t rv;
    wiringPiI2CWrite(bus,DEVICE_ID); // send command
    rv = wiringPiI2CRead(bus) << 8;
    rv += wiringPiI2CRead(bus);
    return rv;
}

// *****************************************************************************
// returns a sting "h.l" could be several bytes
// *****************************************************************************
void sv3_Version(int bus, unsigned char *v)
{
uint8_t h,l;
    wiringPiI2CWrite(bus,DEVICE_VERSION); // send command
    h = wiringPiI2CRead(bus) ;
    l = wiringPiI2CRead(bus);
    sprintf(v,"%d.%d",h,l);
}

// *****************************************************************************
// *****************************************************************************
void sv3_reset(int bus)
{
int k;
    wiringPiI2CWrite(bus,DEVICE_RESET); // send command
    for(k=0;k<=100;k++); usleep(1000); // 100 mS
}

#endif
